% Angewandte Numerik 2, Wintersemester 2016/2017, 09.12.2016
% Uebungsblatt 07, Aufgabe 25: Verschiedene B-Spline-Basisfunktionen
%
% Hauptprogramm:
% Plottet alle B-Spline-Basisfunktionen zum angegebenen Knotenvektor
% und vom Grad 0 bis zum Grad maxGrad



clear all;
close all;
clc;



%% Initialisierungen: Aenderbar

bsp       = 'a';        % Waehlt Teilaufgabe aus
anzXWerte = 200;        % Feinheit der Diskretisierung fuer den Plot



%% Definition der Teilaufgaben

switch bsp
    case 'a'            % Blatt 7, Aufgabe 25, Teilaufgabe a)
        maxGrad = 3;
        ti      = [0, 0, 0, 0, 0.5, 0.5, 1, 1, 1, 1];
    case 'b'            % Blatt 7, Aufgabe 25, Teilaufgabe b)
        maxGrad = 3;
        ti      = [0, 0, 0, 0, 0.3, 0.6, 1, 1, 1, 1];
    case 'c'            % Blatt 7, Aufgabe 25, Teilaufgabe c)
        maxGrad = 3;
        ti      = [0, 0, 0, 0, 0.3, 0.8, 1, 1, 1, 1];
    case 'd'            % Blatt 7, Aufgabe 25, Teilaufgabe d)
        maxGrad = 4;
        ti      = [0, 0, 0, 0, 0, 0.25, 0.5, 0.5, 0.75, 1, 1, 1, 1, 1];
    case 'e'            % wie d), aber Knoten 0.5 vierfach
        maxGrad = 4;
        ti      = [0, 0, 0, 0, 0, 0.25, 0.5, 0.5, 0.5, 0.5, 0.75, 1, 1, 1, 1, 1];
    case 'f'            % wie e), aber maxGrad 5
        maxGrad = 5;
        ti      = [0, 0, 0, 0, 0, 0.25, 0.5, 0.5, 0.5, 0.5, 0.75, 1, 1, 1, 1, 1];
    otherwise
        error('Teilaufgabe ''%s'' nicht implementiert', bsp);
end



%% B-Spline-Basisfunktionen auswerten und plotten

for grad = 0:maxGrad
    
    xWerte  = linspace(ti(1+grad), ti(end-grad), anzXWerte);
    % Diskretisierung des zulaessigen Gesamt-Intervalls 

    lenTi   = length(ti);       % Anzahl der Knoten
 
    C       = eye(lenTi-grad-1);
    % Jede Zeile ist ein Koeffizientenvektor,
    % jede Zeile liefert eine B-Spline-Bsisfunktion vom Grad grad

    sxWerte = zeros(length(xWerte), lenTi-1);
    % Funktionswerte der B-Spline-Basisfunktionen:
    % Fuer jeden diskreten x-Wert eine Zeile,
    % fuer jede B-Spline-Basisfunktion eine Spalte
    
    legendStr = cell(lenTi-grad-1, 1);
    % Strings fuer die Legende, fuer jedes Schaubild neu
    
    for i = 1:lenTi-grad-1  % alle B-Spline-Basisfunktionen
        sxWerte(:, i) = bSplineAuswertung(ti, grad, C(:,i), xWerte);
        legendStr{i} = sprintf('N_{%d}^{%d}', i-1, grad);
    end

    figure;
    plot(xWerte, sxWerte)
    hold on
    plot([ti(1)-0.2, ti(end)+0.5], [0, 0], 'k');    % x-Achse
    plot([0, 0], [-0.2, 1.2], 'k');                 % y-Achse

    xlabel('x');
    ylabelStr = sprintf('N_i^%d(x)', grad);
    ylabel(ylabelStr);
    titleStr = 'B-Spline-Basisfunktionen vom Grad';
    titleStr = sprintf('%s %d zum Knotenvektor (', titleStr, grad);
    titleStr = sprintf('%s%g', titleStr, ti(1));
    for i = 2:length(ti)
        titleStr = sprintf('%s, %g', titleStr, ti(i));
    end
    titleStr = sprintf('%s)', titleStr);
    title(titleStr);
    axis([ti(1)-0.2, ti(end)+0.5, -0.2, 1.2])
    legend(legendStr)
    hold off
end
